VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Core"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'CookieRevised adds:
'Always use Option Explicit as the first line of every module, form, class...
Option Explicit

Public Function Initialize(ByVal nVersion As Long, ByVal sUserEmail As String, ByVal oMessenger As Object) As Boolean
    
    'spam = DisplayToast(PluginName & " " & PluginVer & Chr(10) & "Loaded!", PluginName, "", False)
    '  CookieRevised adds:
    '  Since you use the DisplayToast() function, check if the plugin API is version 3
    '  or higher! See MPPluginConst module.
    '
    '  Also, where is the variable spam defined??? If you use a variable, always declare it first.
    '  Note also that you already defined a global variable called spam as a string. And that
    '  DisplayToast will return a boolean if used as a function. In short, no need to use a (undefined)
    '  variable at all, simply use the function as a sub.
    If nVersion >= 3 Then
      InitVars sUserEmail
      DisplayToast PluginName & " " & PluginVer & Chr(10) & "Loaded!", PluginName, "", False
      Initialize = True
    Else
      MsgBox "This Messenger Plus! version does not support this plugin."
      Initialize = False
    End If
    
End Function

Public Function Uninitialize()
End Function

Public Function Configure()
    frmConfig.Show vbModal
End Function

Public Function GetPublishInfo(ByRef sPluginName As String, ByRef nCommandCount As Long, ByRef nTagCount As Long) As Boolean
    sPluginName = "FreedomPlugin"
    nCommandCount = 6
    nTagCount = 0
    
    GetPublishInfo = True
End Function

Public Function GetPublishCommandInfo(ByVal nCommandIdx As Long, ByRef sName As String, ByRef sValue As String, ByRef sHelp As String)
    'CookieRevised adds:
    'The IF THEN use here is rather long and should be changed to a SELECT CASE
    'structure.
    Select Case nCommandIdx
      Case 1
        sName = "Dice Roll"
        sValue = "xroll"
        sHelp = ""
      Case 2
        sName = "Bold Name"
        sValue = "xbn"
        sHelp = "name goes here"
      Case 3
        sName = "WRY!"
        sValue = "xwry"
        sHelp = ""
      Case 4
        sName = "8 Ball"
        sValue = "xb"
        sHelp = ""
      Case 5
        sName = "Game Status"
        sValue = "xgs"
        sHelp = "0 for normal, 1 for boldname>^<name>^<game>^<message"
      Case 6
        sName = "Sleep Status"
        sValue = "xss"
        sHelp = "0 for normal, 1 for boldname>^<name>^<message"
    End If
End Function

Public Function ParseCommand(ByVal sCommand As String, ByVal sCommandArg As String, ByVal oConversationWnd As Object, ByRef sResult As String) As Boolean
    Dim iRoll  As Integer
    Dim iSides As Integer
    Dim spam() As String
    
    'CookieRevised adds:
    '1) The IF THEN use here is rather long and should be changed to a SELECT CASE structure.
    '2) The use of StrComp() is very slow and even not needed
    '3) lots of other useless and/or slow stuff...
    '4) lots of bugs and potential problems...
    '5) etc...
    'Too many things to comment all in detail, so here is the fixed procedure in one go:
    
    ParseCommand = True
    
    Select Case LCase$(sCommand)
      Case "/xroll"
        Randomize
        iSides = IIf(sCommandArg <> "", Val(sCommandArg), 6)
        iRoll = Int(Rnd * sSides) + 1
        sResult = Chr(nCCBold) & Chr(nCCColor) & "1" & _
                  "=-= GODDAMN DICEROLLER =-=" & Chr(10) & _
                  "   Result: " & Chr(nCCColor) & "37 " & iRoll & _
                  Chr(nCCColor) & "1" & Chr(10) & "   Sides:  " & Chr(nCCColor) & "37 " & _
                  iSides
        
        
      Case "/xbn" ' <name goes here>
        If sCommandArg <> "" Then
          SetNewName Chr(nCCBold) & sCommandArg
        Else
          MsgBox "Parameter missing"
        End If
        
        
      Case "/xbns" ' <name goes here>
        If sCommandArg <> "" Then
          SetNewName "     " & Chr(nCCBold) & sCommandArg
        Else
          MsgBox "Parameter missing"
        End If
        
        
      Case "/xb"
        Select Case sCommandArg
          Case "1q": YesReply
          Case "2w": NoReply
          Case "3e": MaybeReply
          Case Else
            Randomize
            Select Case Int(Rnd * 12) + 1
                Case 1 To 4: YesReply
                Case 5 To 8: NoReply
                Case 9 To 12: MaybeReply
            End Select
        End Select
        sResult = Chr(nCCBold) & Chr(nCCColor) & "1" & _
                  "=-= GODDAMN 8BALL =-=" & Chr(10) & _
                  "   8ball sez: " & Chr(nCCColor) & "37 " & s8ball & Chr(10) & _
                  Chr(nCCColor) & "1" & "   Category: " & Chr(nCCColor) & "37 " & s8ballresult
      
      
      Case "/xgs" ' <0 for normal, 1 for boldname>^<name>^<game>^<message>"
        spam = Split(sCommandArg, "^", 4)
        If UBound(spam) = 3 Then
          SetNewName IIf(spam(0) = "1", Chr(nCCBold), "") & spam(1) & " - Playing " & spam(2)
          sResult = "/online " + spam(3)
        Else
          MsgBox "Parameters missing"
        End If
      
      
      Case "/xgss" ' <0 for normal, 1 for boldname>^<name>^<game>^<message>"
        spam = Split(sCommandArg, "^", 4)
        If UBound(spam) = 3 Then
          If spam(0) = "1" Then
            SetNewName "     " & Chr(nCCBold) & spam(1) & " - Playing " & spam(2)
          Else
            SetNewName spam(1) & " - Playing " & Chr(nCCBold) & spam(2)
          End If
          sResult = "/online " + spam(3)
        Else
          MsgBox "Parameters missing"
        End If
      
      
      Case "/xss" ' <0 for normal, 1 for boldname>^<name>^<message>
        spam = Split(sCommandArg, "^", 3)
        If UBound(spam) = 2 Then
          SetNewName IIf(spam(0) = "1", Chr(nCCBold), "") & spam(1) & " - Sleeping"
          sResult = "/away " & spam(2)
        Else
          MsgBox "Parameters missing"
        End If
      
      
      Case "/xsss" ' <0 for normal, 1 for boldname>^<name>^<message>
        spam = Split(sCommandArg, "^", 3)
        If UBound(spam) = 2 Then
          If spam(0) = "1" Then
            SetNewName "     " & Chr(nCCBold) & spam(1) & " - Sleeping"
          Else
            SetNewName "     " & spam(1) & " - Sleeping"
          End If
          sResult = "/away " & spam(2)
        Else
          MsgBox "Parameters missing"
        End If
        
        
      Case "/xwry"
        sResult = Chr(nCCNotify) & "wryyy" & _
                  "WRYYYYYYYYYYYYYYYYYYYY!!11!11one"
      
      
      Case "/xwryon"
        AddToINI "Settings_" & sUser, "Wry", "True", ini
        sWry = True
        
        
      Case "/xwryoff"
        AddToINI "Settings_" & sUser, "Wry", "False", ini
        sWry = False
        
      Case Else
        ParseCommand = False
    End Select
    
End Function

Public Function ParseTag(ByVal sTag As String, ByVal oConversationWnd As Object, ByRef sResult As String) As Boolean
    'CookieRevised adds:
    '1) The IF THEN use here is rather long and should be changed to a SELECT CASE structure.
    '2) The use of StrComp() is very slow and even not needed
    '3) bugs...
    
    ParseTag = True
    
    Select Case UCase$(sTag)
      Case "(!XDIRTYQUOTE)"
        Randomize
        Select Case Int(Rnd * 3)
          Case 0: sResult = "[quote 1]"
          Case 1: sResult = "[quote 2]"
          Case 2: sResult = "[quote 3]"
      Case "(!XDIRTYFAIL)"
        sResult = "Failed? Who failed?"
      Case Else
        ParseTag = False
    End Select

End Function

Public Function ReceiveNotify(ByVal sNotifyCode As String, ByVal sText As String, ByVal sContactName As String, ByVal oConversationWnd As Object, ByRef sTextToSend As String) As Boolean
    Dim spam As String
    
    ReceiveNotify = True
    
    Select Case LCase$(sNotifyCode)
      Case "wryyy"
        If sWry = True Then sndPlaySound32 App.Path + "\wry.wav", 1
      Case Else
        ReceiveNotify = False
    End If
    
End Function
